<?php

define('LAECHONW_YOU_HAVE_NOT_ADDED_ANY_API_KEY',   __('You have not added any API Key'));
define('LAECHONW_API_KEY_ADDED',                    __('API Key has been added successfully'));
define('LAECHONW_ERROR_LOADING_API_KEYS',           __('Error occured while trying to load the API Keys. Please try again later'));
define('LAECHONW_CURRENTLY_PUBLISHING',             __('You are currently Publishing your Blog to'));
define('LAECHONW_SOCIAL_NETWORKS',                  __('Networks'));
define('LAECHONW_SOCIAL_NETWORK',                   __('Network'));
define('LAECHONW_PLUGIN_NAME',                      __('sd-nw'));
define('LAECHONW_PLUGIN_VERSION',                   '5.7.2');
define('LAECHONW_WIDGET_NAME_POST_EDITOR', 			__('Social Discussions'));
define('LAECHONW_WP_PLUGIN_URL',                  	laechonw_get_plugin_dir());
define('LAECHONW_SOCIAL_NETWORKS',                 __('Networks'));
define('LAECHONW_SOCIAL_NETWORK',                  __('Network'));

add_action('admin_notices', 'laechonw_auth_errors');

function laechonw_set_options() {
	$options = get_option(LAECHONW_WIDGET_NAME_INTERNAL);
	if(!array_key_exists('laechonw_auth_error_show', $options)) {
		$options['laechonw_auth_error_show'] = 1;
	}
	if(!array_key_exists('laechonw_mixed_mode_alert_show', $options)) {
		$options['laechonw_mixed_mode_alert_show'] = 1;
	}
	update_option(LAECHONW_WIDGET_NAME_INTERNAL, $options);
}

function laechonw_load_options() {
	global $laechonw_auth_error_show, $laechonw_mixed_mode_alert_show;
	$options = get_option(LAECHONW_WIDGET_NAME_INTERNAL);
	if(is_array($options)) {
		//Auth Error show hide
    	if(array_key_exists('laechonw_auth_error_show', $options)) {
			$laechonw_auth_error_show = $options['laechonw_auth_error_show'];
			if($laechonw_auth_error_show) {
				$laechonw_auth_error_show = 'checked';	
			} else {
				$laechonw_auth_error_show = '';
			}
		} else {
			$laechonw_auth_error_show = 'checked';
		}
		//Mixed Mode Alert
    	if(array_key_exists('laechonw_mixed_mode_alert_show', $options)) {
			$laechonw_mixed_mode_alert_show = $options['laechonw_mixed_mode_alert_show'];
			if($laechonw_mixed_mode_alert_show) {
				$laechonw_mixed_mode_alert_show = 'checked';	
			} else {
				$laechonw_mixed_mode_alert_show = '';
			}
		} else {
			$laechonw_mixed_mode_alert_show = 'checked';
		}
	} else {
		$laechonw_auth_error_show = 'checked';
		$laechonw_mixed_mode_alert_show = 'checked';
	}
	laechonw_mixed_mode();
}

add_action('admin_head', 'laechonw_save_options_javascript');

function laechonw_save_options_javascript() {
?>
<script type="text/javascript" >
jQuery(document).ready(function($) {
	jQuery(".lanetworkpuboptions").live("click", function() {
		var this_form = jQuery(this).parents('form:first');
		var laecho_ajax_msg = jQuery(this).parents(".laecho_nw_content_box:first").prev();
		laecho_ajax_msg.show();
		laecho_ajax_msg.html('Updating...');
		jQuery.post(ajaxurl, this_form.serialize(), function(data) {
			laecho_ajax_msg.html('Setting has been updated successfully');
			social_discussions_msg_fade(laecho_ajax_msg);
		});
        return false;
    });
});
</script>
<?php
}

add_action('wp_ajax_laechonw_save_options', 'laechonw_save_options');

function laechonw_save_options() {
	if ($_POST['laechonw_form_type'] == 'laechonw_auth_error_show') {
		if(array_key_exists('laechonw_auth_error_show', $_POST)) {
			$laechonw_auth_error_show = 1;	
		} else {
			$laechonw_auth_error_show = 0;
		}
		laechonw_auth_error_show($laechonw_auth_error_show);
		echo 'updated';	
	} elseif ($_POST['laechonw_form_type'] == 'laechonw_mixed_mode_alert_show') {
		if(array_key_exists('laechonw_mixed_mode_alert_show', $_POST)) {
			$laechonw_mixed_mode_alert_show = 1;	
		} else {
			$laechonw_mixed_mode_alert_show = 0;
		}
		laechonw_mixed_mode_alert_show($laechonw_mixed_mode_alert_show);
		echo 'updated';	
	}
	return;
}

function laechonw_auth_errors() {
	//Get options
	$options = get_option(LAECHONW_WIDGET_NAME_INTERNAL);
	if(!is_array($options)) {
		return;
	}
	if(empty($options['laechonw_auth_error_show'])) {
		return;
	}
	$laechonw_auth_error_show = $options['laechonw_auth_error_show'];
	if(!$laechonw_auth_error_show) {
		return;
	}
	if (empty($options['api_key'])) {
		return;
	}
	$api_key = $options['api_key'];
	$link = 'http://www.linksalpha.com/a/networkpubautherrors';
	$params = array('api_key'=>$api_key,
					'plugin'=>LAECHONW_PLUGIN_NAME,
					'plugin_version'=>laechonw_version(),
					);
	$response_full = laechonw_http_post($link, $params);
	$response_code = $response_full[0];
	if($response_code == 200) {
        return;
	}
	if($response_code == 401) {
		echo "
		<div class='updated fade' style='padding:10px;'>
			<div style='color:red;font-weight:bold;'>
				<img src='".LAECHONW_WP_PLUGIN_URL ."/icons/alert.png' style='vertical-align:text-bottom;' />&nbsp;".LAECHONW_WIDGET_NAME_POST_EDITOR.' - '.__("Authorization Error")."
			</div>
			<div style='padding-top:0px;'>
				".__("Authorization provided on one or more of your Network accounts has expired. Please")." <a target='_blank' href='http://www.linksalpha.com/networks'>".__("add the related Account")."</a> ".__("again to be able to publish content. To learn more, ")."<a target='_blank' href='http://help.linksalpha.com/networks/authorization-error'>".__("Click Here")."</a>. ".__("To access Settings page of the plugin, ")."<a href='".LAECHO_PLUGIN_ADMIN_URL."'>".__("Click Here.")."</a>
			</div>
		</div>
		";
        return;
	}
    return;
}

function laechonw_auth_error_show($laechonw_auth_error_show) {
	$options = get_option(LAECHONW_WIDGET_NAME_INTERNAL);
	$options['laechonw_auth_error_show'] = $laechonw_auth_error_show;
	update_option(LAECHONW_WIDGET_NAME_INTERNAL, $options);
	return;
}

function laechonw_mixed_mode() {
	$options = get_option(LAECHONW_WIDGET_NAME_INTERNAL);
	if(!is_array($options)) {
		return;
	}
	if(empty($options['laechonw_mixed_mode_alert_show'])) {
		return;
	}
	$laechonw_mixed_mode_alert_show = $options['laechonw_mixed_mode_alert_show'];
	if(!$laechonw_mixed_mode_alert_show) {
		return;
	}
	if (empty($options['id_2'])) {
		return;
	}
	$id = $options['id_2'];
	$link = 'http://www.linksalpha.com/a/networkpubmixedmode';
	$params = array('id'=>$id,
					'plugin'=>LAECHONW_PLUGIN_NAME,
					'plugin_version'=>laechonw_version(),
					);
	$response_full = laechonw_http_post($link, $params);
	$response_code = $response_full[0];
	if($response_code == 200) {
		$response = laechonw_json_decode($response_full[1]);
		if ($response->errorCode > 0) {
			if($response->errorMessage == 'mixed mode') {
				echo "
				<div class='updated fade' style='padding:10px;'>
					<div style='color:red;font-weight:bold;'>
						<img src='".LAECHONW_WP_PLUGIN_URL ."/icons/alert.png' style='vertical-align:text-bottom;' />&nbsp;".LAECHONW_WIDGET_NAME_POST_EDITOR.' - '.__("Mixed Mode Alert")."
					</div>
					<div style='padding-top:0px;'>
						".__("Publishing of your website content via LinksAlpha Network Publisher seems to be configured using both the Network Publisher Plugin and RSS Feed of your website. LinksAlpha recommends use of Network Publisher plugin over RSS Feed. ")."<a target='_blank' href='http://help.linksalpha.com/wordpress-plugin-network-publisher/mixed-mode-alert'>".__("Click here")."</a> ".__("to read the help document that will help resolve this Mixed Mode configuration issue.")."
					</div>
				</div>
				";
			}
		}
	}
}


function laechonw_mixed_mode_alert_show($laechonw_mixed_mode_alert_show) {
	$options = get_option(LAECHONW_WIDGET_NAME_INTERNAL);
	$options['laechonw_mixed_mode_alert_show'] = $laechonw_mixed_mode_alert_show;
	update_option(LAECHONW_WIDGET_NAME_INTERNAL, $options);
	return;
}


function laechonw_networkping($id) {
	if(!$id) {
		return FALSE;
	}
	$options = get_option(LAECHONW_WIDGET_NAME_INTERNAL);
	if(empty($options['laechonw_id']) or empty($options['api_key'])) {
		return;
	}
	$link = 'http://www.linksalpha.com/a/ping?id='.$options['laechonw_id'];
	$response_full = laechonw_http($link);
	return;
}


function laechonw_networkping_custom($new, $old, $post) {
    if ($new == 'publish' && $old != 'publish') {
        $post_types = get_post_types( array('public' => true), 'objects' );
        foreach ( $post_types as $post_type ) {
            if ( $post->post_type == $post_type->name ) {
                laechonw_networkping($post->ID, $post);
                break;
            }
        }
	}
    return;
}


function laechonw_convert($id) {
	if(!$id) {
		return;
	}
	$options = get_option(LAECHONW_WIDGET_NAME_INTERNAL);
	if(!empty($options['id_2'])) {
		return;
	}
	if(empty($options['laechonw_id']) or empty($options['api_key'])) {
		return;
	}
	// Build Params
	$link = 'http://www.linksalpha.com/a/networkpubconvert';
	$params = array('id'=>$options['laechonw_id'],
					'api_key'=>$options['api_key'],
					'plugin'=>LAECHONW_PLUGIN_NAME,
					);
	//HTTP Call
	$response_full = laechonw_http_post($link, $params);
	$response_code = $response_full[0];
	if ($response_code != 200) {
		return;
	}
	$response = laechonw_json_decode($response_full[1]);
	if ($response->errorCode > 0) {
		return;
	}
	//Update options
	$options['id_2'] = $response->results;
	//Save
	update_option(LAECHONW_WIDGET_NAME_INTERNAL, $options);
	return;
}


function laechonw_post($post_id) {
	//Network keys
	$options = get_option(LAECHONW_WIDGET_NAME_INTERNAL);
	if (empty($options['api_key']) or empty($options['id_2'])) {
		return;
	}
	$id = $options['id_2'];
	$api_key = $options['api_key'];
    //Post data
	$post_data = get_post( $post_id, ARRAY_A );
    //Post Published?
	if(in_array($post_data['post_status'], array('future', 'publish'))) {
        //Post too old
        $post_date = strtotime($post_data['post_date_gmt']);
        $current_date = time();
        $diff = $current_date - $post_date;
        $days = floor( $diff / (60*60*24) );
        if($days > 3) {
            return;
        }
		//Post data: id, content and title
		$post_title = $post_data['post_title'];
		$post_content = $post_data['post_content'];
		//Post data: Permalink
		$post_link = get_permalink($post_id);
		//Post data: Categories
		$post_categories_array = array();
		$post_categories_data = get_the_category( $post_id );
		foreach($post_categories_data as $category) {
			$post_categories_array[] = $category->cat_name;
		}
		$post_categories = implode(",", $post_categories_array);
		//Post tags
		$post_tags_array = array();
		$post_tags_data = wp_get_post_tags( $post_id );
		foreach($post_tags_data as $tag) {
			$post_tags_array[] = $tag->name;
		}
		$post_tags = implode(",", $post_tags_array);
		//Post Geo
		if(function_exists('get_wpgeo_latitude')) {
			if(get_wpgeo_latitude( $post_id ) and get_wpgeo_longitude( $post_id )) {
				$post_geotag = get_wpgeo_latitude( $post_id ).' '.get_wpgeo_longitude( $post_id );
			}
		}
		if(!isset($post_geotag)) {
			$post_geotag = '';
		}
		// Build Params
		$link = 'http://www.linksalpha.com/a/networkpubpost';
		$params = array('id'=>$id,
						'api_key'=>$api_key,
						'post_id'=>$post_id,
						'post_link'=>$post_link,
						'post_title'=>$post_title,
						'post_content'=>$post_content,
						'plugin'=>LAECHONW_PLUGIN_NAME,
						'plugin_version'=>laechonw_version(),
						'post_categories'=>$post_categories,
						'post_tags'=>$post_tags,
						'post_geotag'=>$post_geotag
						);
		//Featured Image
		$post_image = laechonw_thumbnail_link( $post_id );
		if($post_image) {
			$params['post_image'] = $post_image;
		}
		//HTTP Call
		$response_full = laechonw_http_post($link,$params);
	}
	return;
}


function laechonw_post_xmlrpc($post_id) {
    laechonw_post($post_id);
}


function laechonw_post_custom($new, $old, $post) {
    if ($new == 'publish' && $old != 'publish') {
        $post_types = get_post_types( array('public' => true), 'objects' );
        foreach ( $post_types as $post_type ) {
            if ( $post->post_type == $post_type->name ) {
                laechonw_post($post->ID);
                break;
            }
        }
	}
    return;
}


function laechonw_networkpub_add($api_key) {
	if (!$api_key) {
		$errdesc = laechonw_error_msgs('invalid key');
		return array(1, $errdesc);
	}
	$url = get_bloginfo('url');
    if (!$url) {
		$errdesc = laechonw_error_msgs('invalid url');
		return array(1, $errdesc);
	}
	$desc = get_bloginfo('description');
	$options = get_option(LAECHONW_WIDGET_NAME_INTERNAL);
	if(!empty($options['laechonw_id'])) {
		$id = $options['laechonw_id'];
	} elseif (!empty($options['id_2'])) {
		$id = $options['id_2'];
	} else {
		$id = '';
	}
	
	$url_parsed = parse_url($url);
	$url_host = $url_parsed['host'];
	if( substr_count($url, 'localhost') or strpos($url_host, '192.168.') === 0 or strpos($url_host, '127.0.0') === 0 or (strpos($url_host, '172.') === 0 and (int)substr($url_host, 4, 2) > 15 and (int)substr($url_host, 4, 2) < 32 ) or strpos($url_host, '10.') === 0 ) {
		$errdesc = laechonw_error_msgs('localhost url');
		return array(1, $errdesc);
	}
	$link   = 'http://www.linksalpha.com/a/networkpubaddone';
	// Build Params
	$params = array('url'=>urlencode($url),
					'key'=>$api_key,
					'plugin'=>LAECHONW_PLUGIN_NAME,
					'version'=>LAECHONW_PLUGIN_VERSION,
					'all_keys'=>$options['api_key'],
					'id'=>$id);
	//HTTP Call
	$response_full = laechonw_http_post($link,$params);
	$response_code = $response_full[0];
	if ($response_code != 200) {
		$errdesc = laechonw_error_msgs($response_full[1]);
		return array(1, $errdesc);
	}
	$response = laechonw_json_decode($response_full[1]);
	if ($response->errorCode > 0) {
		$errdesc = laechonw_error_msgs($response->errorMessage);
		return array(1, $errdesc);
	}
	//Update options - Site id
	$options['id_2'] = $response->results->id;
	//Update options - Network Keys
	if(empty($options['api_key'])) {
		$options['api_key'] = $response->results->api_key;	
	} else {
		$option_api_key_array = explode(',', $options['api_key']);
		$option_api_key_new = $response->results->api_key;
		$option_api_key_new_array = explode(',', $option_api_key_new);
		foreach($option_api_key_new_array as $key=>$val) {
			if(!in_array($val, $option_api_key_array)) {
				$options['api_key'] = $options['api_key'].','.$val;
			}
		}
	}
	//Save
	update_option(LAECHONW_WIDGET_NAME_INTERNAL, $options);
	//Return
	$html = '<div class="laecho_notice_msg_save">API Key has been added successfully</div>';
	return array(2, $html);
}

add_action('admin_head', 'laechonw_networkpub_load_javascript');

function laechonw_networkpub_load_javascript() {
?>
<script type="text/javascript" >
	jQuery(document).ready(function($) {
		social_discussions_ajaxurl = ajaxurl; 
		jQuery("#social_discussions_header_link_networkpub").live("click", function() {
			jQuery.post(ajaxurl, {request_type: 'ajax'}, function(data, textStatus) {
				if(data == '500') {
					jQuery("#idAPIBox").html('<div class="laecho_nw_error">Error occured while loading your Publications. Please try again later or open ticket with <a target="_blank" href="http://support.linksalpha.com">LinksAlpha Support</a>.</div>');
				} else {
					var remove_string = 'updated-1';
					if(data.indexOf(remove_string) > -1) {
						data=data.substring(0, data.length - remove_string.length);
					}
					var remove_string = '-1';
					if(data.indexOf(remove_string) > -1) {
						data=data.substring(0, data.length - remove_string.length);
					}
					jQuery("#idAPIBox").html(data);
				}
			}).error(function(){
				jQuery("#idAPIBox").html('<div class="laecho_nw_error">Error occured while loading your Publications. Please try again later or open ticket with <a target="_blank" href="http://support.linksalpha.com">LinksAlpha Support</a>.</div>');
			});
		});
	});
</script>
<?php
}

add_action('wp_ajax_laechonw_networkpub_load', 'laechonw_networkpub_load');

function laechonw_networkpub_load() {
	if(empty($_POST)) {
		return;
	}
	if(!array_key_exists('request_type', $_POST)) {
		return;
	}
	$options = get_option(LAECHONW_WIDGET_NAME_INTERNAL);
	if (empty($options['api_key'])) {		
		$html = '<div class="laecho_nw_error">'.LAECHONW_YOU_HAVE_NOT_ADDED_ANY_API_KEY.'</div>';
		echo $html;
		return;
	}
	$link = 'http://www.linksalpha.com/a/networkpubget';
	$body = array('key'=>$options['api_key'], 'version'=>2);	
	$response_full = laechonw_http_post($link, $body);
	$response_code = $response_full[0];
	if ($response_code != 200) {
		$html = laechonw_error_msgs($response_full[1]); 
		echo $html;
		return;		
	}
	$response = laechonw_json_decode($response_full[1]);
	if($response->errorCode > 0) {
		$html = '<div class="laecho_nw_error">'.LAECHONW_ERROR_LOADING_API_KEYS.'.</div>';
		echo $html;
		return;
	}
	if(count($response->results_deleted)) {
		$option_api_key_array = explode(',', $options['api_key']);
		foreach($response->results_deleted as $row) {
			if(in_array($row, $option_api_key_array)) {
				$pos = $option_api_key_array[$row];
				unset($option_api_key_array[$pos]);
			}
		}
		$api_key = implode(",", $option_api_key_array);
		$options['api_key'] = $api_key;
		update_option(LAECHONW_WIDGET_NAME_INTERNAL, $options);
	}
	if(!count($response->results)) {
		$html = '<div class="laecho_nw_error">You have not added an API Key</div>';
		echo $html;
		return;
	}
	if(count($response->results) == 1) {
		$html = '<div style="padding:0px 10px 10px 10px;">'.LAECHONW_CURRENTLY_PUBLISHING.'&nbsp;<span id="lanetworkpub_pub_count">'.count($response->results).'&nbsp;'.LAECHONW_SOCIAL_NETWORK.'</span></div>';	
	} else {
		$html = '<div style="padding:0px 10px 10px 10px;">'.LAECHONW_CURRENTLY_PUBLISHING.'&nbsp;<span id="lanetworkpub_pub_count">'.count($response->results).'&nbsp;'.LAECHONW_SOCIAL_NETWORKS.'</span></div>';
	}
	$html .= '<table class="networkpub_added"><tr><th>'.__('Network').'</th><th>'.__('Option').'</th><th>'.__('Remove').'</th></tr>';
	$i = 1;
	foreach($response->results as $row) {
		$html .= '<tr id="r_key_'.$row->api_key.'">';
		if($i&1) {
			$html .= '<td>';
		} else {
			$html .= '<td style="background-color:#F7F7F7;">';
		}
		$html .= '<a target="_blank" href="'.$row->profile_url.'">'.$row->name.'</a></td>';
		if($i&1) {
			$html .= '<td style="text-align:center;">';
		} else {
			$html .= '<td style="text-align:center;background-color:#F7F7F7;">';
		}
		$html .= '<a href="http://www.linksalpha.com/a/networkpuboptions?api_key='.$row->api_key.'&id='.$options['id_2'].'&version='.laechonw_version().'&KeepThis=true&TB_iframe=true&height=465&width=650" title="Publish Options" class="thickbox" type="button">'.__('Options').'</a></td>';
		if($i&1) {
			$html .= '<td style="text-align:center;">';
		} else {
			$html .= '<td style="text-align:center;background-color:#F7F7F7;">';
		}
		$html .= '<a href="#" id="key_'.$row->api_key.'" class="lanetworkpubre">'.__('Remove').'</a></td>';
		$html .= '</tr>';
		$i++;
	}
	$html .= '</table>';
	echo $html;
	return;
}


add_action('admin_head', 'laechonw_networkpub_remove_javascript');

function laechonw_networkpub_remove_javascript() {
?>
<script type="text/javascript" >
	jQuery(document).ready(function($) {
		jQuery(".lanetworkpubre").live("click", function() {
			var laecho_ajax_msg = jQuery(this).parents(".laecho_nw_content_box:first").prev();
			laecho_ajax_msg.show();
	        laecho_ajax_msg.html('Removing...');
	        var key = jQuery(this).attr("id");
	        var this_row = jQuery(this).parents('tr:first');
	        this_row.css('opacity', '.30');
	        jQuery.post(ajaxurl, {laechonw_networkpub_key:key, type:'remove'}, function(data) {
	            if (data == '500') {
	            	laecho_ajax_msg.html('Error occured while removing the Network. As a workaround, you can remove this publishing at the following link: <a target="_blank" href="http://www.linksalpha.com/publisher/pubs">LinksAlpha Publisher</a>');
	            } else {
	                this_row.remove();
	                laecho_ajax_msg.html('Network has been removed successfully');
	                var lanetworkpub_pub_count = jQuery(".lanetworkpub_remove").length;
	                if(lanetworkpub_pub_count > 1) {
	                	$("#lanetworkpub_pub_count").html(lanetworkpub_pub_count+' <?php echo LAECHONW_SOCIAL_NETWORKS ?>');
			        } else {
			        	$("#lanetworkpub_pub_count").html(lanetworkpub_pub_count+' <?php echo LAECHONW_SOCIAL_NETWORK ?>');
			        }
	            }
	            social_discussions_msg_fade(laecho_ajax_msg);
	        });
	        return false;
	    });
	});
</script>
<?php
}

add_action('wp_ajax_laechonw_networkpub_remove', 'laechonw_networkpub_remove');

function laechonw_networkpub_remove() {
	if(empty($_POST)) {
		return;
	}
	$options = get_option(LAECHONW_WIDGET_NAME_INTERNAL);
	if (!empty($_POST['laechonw_networkpub_key'])) {
		$key_full = $_POST['laechonw_networkpub_key'];
		$key_only = trim(substr($key_full, 4));
		$link = 'http://www.linksalpha.com/a/networkpubremove';
		$body = array('id'=>$options['id_2'], 'key'=>$key_only);
		$response_full = laechonw_http_post($link, $body);
		$response_code = $response_full[0];
		if ($response_code != 200) {
			$errdesc = laechonw_error_msgs($response_full[1]); 
			echo $errdesc;		
			return;
		}
		$api_key = $options['api_key'];
		$api_key_array = explode(',', $api_key);
		$loc = array_search($key_only, $api_key_array, True);
		if($loc !== FALSE) {
			unset($api_key_array[$loc]);
		}
		$api_key = implode(",", $api_key_array);
		$options['api_key'] = $api_key;
		update_option(LAECHONW_WIDGET_NAME_INTERNAL, $options);
		echo $key_full;
		return;
	}
}

function laechonw_json_decode($str) {
	if (function_exists("json_decode")) {
	    return json_decode($str);
	} else {
		if (!class_exists('Services_JSON')) {
			require_once("JSON.php");
		}
	    $json = new Services_JSON();
	    return $json->decode($str);
	}
}


function laechonw_http($link) {
	if (!$link) {
		return array(500, 'invalid url');
	}
	if( !class_exists( 'WP_Http' ) ) {
		include_once( ABSPATH . WPINC. '/class-http.php' );
	}
	if (class_exists('WP_Http')) {
		$request = new WP_Http;
		$headers = array( 'Agent' => LAECHONW_WIDGET_NAME.' - '.get_bloginfo('url') );
		$response_full = $request->request( $link );
        if(isset($response_full->errors)) {			
			return array(500, 'internal error');			
		}
		$response_code = $response_full['response']['code'];
		if ($response_code == 200) {
			$response = $response_full['body'];
			return array($response_code, $response);
		}
		$response_msg = $response_full['response']['message'];
		return array($response_code, $response_msg);
	}
	require_once(ABSPATH.WPINC.'/class-snoopy.php');
	$snoop = new Snoopy;
	$snoop->agent = LAECHONW_WIDGET_NAME.' - '.get_bloginfo('url');
	if($snoop->fetchtext($link)){
		if (strpos($snoop->response_code, '200')) {
			$response = $snoop->results;
			return array(200, $response);
		}
	}
	return array(500, 'internal error');
}


function laechonw_http_post($link, $body) {
	if (!$link) {
		return array(500, 'invalid url');
	}
	if( !class_exists( 'WP_Http' ) ) {
		include_once( ABSPATH . WPINC. '/class-http.php' );
	}
	if (class_exists('WP_Http')) {
		$request = new WP_Http;
		$headers = array( 'Agent' => LAECHONW_WIDGET_NAME.' - '.get_bloginfo('url') );
		$response_full = $request->request( $link, array( 'method' => 'POST', 'body' => $body, 'headers'=>$headers) );
		if(isset($response_full->errors)) {
			return array(500, 'internal error');
		}
		$response_code = $response_full['response']['code'];
		if ($response_code == 200) {
			$response = $response_full['body'];
			return array($response_code, $response);
		}
		$response_msg = $response_full['response']['message'];
		return array($response_code, $response_msg);
	}
	require_once(ABSPATH.WPINC.'/class-snoopy.php');
	$snoop = new Snoopy;
	$snoop->agent = LAECHONW_WIDGET_NAME.' - '.get_bloginfo('url');
	if($snoop->submit($link, $body)){
		if (strpos($snoop->response_code, '200')) {
			$response = $snoop->results;
			return array(200, $response);
		} 
	}	
	return array(500, 'internal error');
}


function laechonw_error_msgs($errMsg) {

	$arr_errCodes  = explode(";", $errMsg);
	$errCodesCount = count($arr_errCodes);

	switch (trim($arr_errCodes[0])) {
	
		case 'internal error':
			$html = '<div class="laecho_nw_error">'.__('An unknown error occured. Please try again later. Else, open a ticket with').'&nbsp;<a target="_blank" href="http://support.linksalpha.com">'.__('LinksAlpha Help Desk').'</div>';
			return $html;		
			break;
	
		case 'invalid url':
			$html  = 	'<div class="laecho_nw_error">
							<div class="laecho_nw_error_header"><img src="'.LAECHONW_WP_PLUGIN_URL .'/icons/alert.png" style="vertical-align:text-bottom;" />&nbsp;'.__('Your website URL is invalid').'</div>
							<div>'.__('URL of your website is not valid and as a result LinksAlpha.com is not able to connect to it. You can try adding the website URL directly in the').'&nbsp;'.'<a target="_blank" href="https://www.linksalpha.com/websites">'.__('LinksAlpha Website Manager.').'</a>&nbsp;'.__('If that also does not work, please open a ticket at').'&nbsp;'.'<a target="_blank" href="http://support.linksalpha.com">'.__('LinksAlpha Help Desk.').'</a></div>
						</div>';
			return $html;
			break;
		
		case 'remote url error':
			$html  = 	'<div class="laecho_nw_error">
							<div class="laecho_nw_error_header"><img src="'.LAECHONW_WP_PLUGIN_URL .'/icons/alert.png" style="vertical-align:text-bottom;" />&nbsp;'.__('Remote URL error').'</div>
							<div>'.__('Your website is either loading extremely slowly or it is in maintenance mode. As a result LinksAlpha.com is not able to connect to it. You can try adding the website URL directly in the').'&nbsp;'.'<a target="_blank" href="https://www.linksalpha.com/websites">'.__('LinksAlpha Website Manager.').'</a>&nbsp;'.__('If that also does not work, please open a ticket at').'&nbsp;'.'<a target="_blank" href="http://support.linksalpha.com">'.__('LinksAlpha Help Desk.').'</a></div>
						</div>';
			return $html;
			break;
			
		case 'feed parsing error':
			$html  = 	'<div class="laecho_nw_error">
							<div class="laecho_nw_error_header"><img src="'.LAECHONW_WP_PLUGIN_URL .'/icons/alert.png" style="vertical-align:text-bottom;" />&nbsp;'.__('RSS Feed parsing error').'</div>
							<div>'.__('Your RSS feed has errors and as a result LinksAlpha.com is not able to connect to it. You can try validating your RSS feed using').'&nbsp;'.'<a target="_blank" href="http://feedvalidator.org/">'.__('Feed Validator.').'</a>&nbsp;'.__('If the RSS feed is indeed valid and you continue to face isses, please open a ticket at').'&nbsp;'.'<a target="_blank" href="http://support.linksalpha.com">'.__('LinksAlpha Help Desk.').'</a></div>
						</div>';
			return $html;
			break;

		case 'feed not found':
			$html  = 	'<div class="laecho_nw_error">
							<div class="laecho_nw_error_header"><img src="'.LAECHONW_WP_PLUGIN_URL .'/icons/alert.png" style="vertical-align:text-bottom;" />&nbsp;'.__('RSS Feed URL not found').'</div>
							<div>'.__('Plugin was not able to find RSS feed URL for your website. Please ensure that under Settings').'->'.__('General').'->'.__('Blog address (URL)').'&nbsp;'.__('the URL is filled-in correctly').'</div>
							<div>'.__('If you still face issues, please open a ticket at: ').'<a target="_blank" href="http://support.linksalpha.com/">LinksAlpha.com '.__('Help Desk').'</a></div>
						</div>';
			return $html;
			break;
			
		case 'invalid key':
			$html  = 	'<div class="laecho_nw_error">
							<div class="laecho_nw_error_header"><img src="'.LAECHONW_WP_PLUGIN_URL .'/icons/alert.png" style="vertical-align:text-bottom;" />&nbsp;'.__('Invalid Key').'</div>
							<div>'.__('The').'&nbsp;'.'<a target="_blank" href="https://www.linksalpha.com/account/your_api_key">'.__('User').'</a>&nbsp;'.__('or').'&nbsp;<a target="_blank" href="https://www.linksalpha.com/networks">'.__('Network').'</a>&nbsp;'.__('API key that you entered is not valid. Please input a valid key and try again.').'</div>
							<div>'.__('If you still face issues, please open a ticket at: ').'<a target="_blank" href="http://support.linksalpha.com/">LinksAlpha.com '.__('Help Desk').'</a></div>
						</div>';
			return $html;
			break;
			
		case 'subscription upgrade required':
			$html  = 	'<div class="laecho_nw_error">
							<div class="laecho_nw_error_header"><img src="'.LAECHONW_WP_PLUGIN_URL .'/icons/alert.png" style="vertical-align:text-bottom;" />&nbsp;'.__('Account Error').'</div>
							<div>'.__('Please ').'&nbsp;'.'<a target="_blank" href="http://www.linksalpha.com/account">'.__('Upgrade your Account').'</a>&nbsp;'.__('to be able to Publish to more Networks. You can learn more about LinksAlpha Networks by').'&nbsp;<a target="_blank" href="http://help.linksalpha.com/networks-1">'.__('clicking here').'</a></div>
							<div>'.__('If you still face issues, please open a ticket at: ').'<a target="_blank" href="http://support.linksalpha.com/">LinksAlpha.com '.__('Help Desk').'</a></div>
						</div>';
			return $html;
			break;
			
		case 'localhost url':
			$html  = 	'<div class="laecho_nw_error">
							<div class="laecho_nw_error_header"><img src="'.LAECHONW_WP_PLUGIN_URL .'/icons/alert.png" style="vertical-align:text-bottom;" />&nbsp;'.__('Website/Blog inaccessible').'</div>
							<div>'.__('You are trying to use the plugin on localhost or behind a firewall which is not supported. Please install the plugin on a Wordpress blog on a live server.').'</div>
							<div>'.__('If you still face issues, please open a ticket at: ').'<a target="_blank" href="http://support.linksalpha.com/">LinksAlpha.com '.__('Help Desk').'</a></div>
						</div>';
			return $html;
			break;
			
		case 'multiple accounts':
			$html = '<div class="laecho_nw_error">
                        <div class="laecho_nw_error_header"><img src="'.LAECHONW_WP_PLUGIN_URL .'/icons/alert.png" style="vertical-align:text-bottom;" />&nbsp;Account Error</div>
                        <div>'.__('The key that you entered is for a LinksAlpha account that is different from the currently used account for this website. You can use API key from only one account on this website. Please input a valid <a target="_blank" href="http://www.linksalpha.com/account/your_api_key">User</a> or <a target="_blank" href="http://www.linksalpha.com/user/networks">Network</a> API key and try again').'.</div>
                        <div>'.__('If you still face issues, please open a ticket at: ').'<a target="_blank" href="http://support.linksalpha.com/">LinksAlpha.com '.__('Help Desk').'</a></div>
                    </div>';
			return $html;
			break;
			
		case 'no networks':
			$html = '<div class="laecho_nw_error">
                        <div class="laecho_nw_error_header"><b><img src="'.LAECHONW_WP_PLUGIN_URL .'alert.png" style="vertical-align:text-bottom;" />&nbsp;'.__('No Network Accounts Found').'</b></div>
                        <div>'.__('You should first authorize LinksAlpha to publish to your social network profiles').' <a target="_blank" href="http://www.linksalpha.com/networks">'.__('Click Here').'</a> '.__('to get started.').'</div>
                        <div>'.__('If you still face issues, please open a ticket at: ').'<a target="_blank" href="http://support.linksalpha.com/">LinksAlpha.com '.__('Help Desk').'</a></div>
                    </div>';
			return $html;
			break;
			
		default:
			$html = '<div class="laecho_nw_error">'.__('An unknown error occured. Please try again later. Else, open a ticket with').'&nbsp;<a target="_blank" href="http://support.linksalpha.com">'.__('LinksAlpha Help Desk').'</div>';
			return $html;		
			break;			
	}	
}


function laechonw_get_plugin_dir() {
	global $wp_version;
	if ( version_compare($wp_version, '2.8', '<') ) {
		$path = dirname(plugin_basename(__FILE__));
		if ( $path == '.' )
		$path = '';
		$plugin_path = trailingslashit( plugins_url( $path ) );
	} 
	else {
		$plugin_path = trailingslashit( plugins_url( '', __FILE__) );
	}	
	return $plugin_path;
}


function laechonw_pushpresscheck() {
	$active_plugins = get_option('active_plugins');
	$pushpress_plugin = 'pushpress/pushpress.php';
	$this_plugin_key = array_search($pushpress_plugin, $active_plugins);
	if ($this_plugin_key) {
		$options = get_option(LAECHONW_WIDGET_NAME_INTERNAL);
		if(array_key_exists('laechonw_id', $options)) {
			if($options['laechonw_id']) {
				$link = 'http://www.linksalpha.com/a/pushpress';
				$body = array('id'=>$options['laechonw_id']);
				$response_full = laechonw_http_post($link, $body);
				$response_code = $response_full[0];	
			}	
		}
	}
}


function laechonw_networkpubcheck() {
	$active_plugins = get_option('active_plugins');
	$pushpress_plugin = 'network-publisher/networkpub.php';
	$this_plugin_key = array_search($pushpress_plugin, $active_plugins);
	if ($this_plugin_key) {
		return True;
	}
	return False;
}


function laechonw_thumbnail_link( $post_id ) {
	if(function_exists('get_post_thumbnail_id') and function_exists('wp_get_attachment_image_src')) {
        $src = wp_get_attachment_image_src(get_post_thumbnail_id($post_id), 'medium');
        if($src) {
            $src = $src[0];
            return $src;
        }
    }
	if(!$post_content) {
		return False;
	}
    if(class_exists("DOMDocument") and function_exists('simplexml_import_dom')) {
		libxml_use_internal_errors(true);
        $doc = new DOMDocument();
        if(!($doc->loadHTML($post_content))){
			return False;
		}
		try {
			$xml = @simplexml_import_dom($doc);
			if($xml) {
				$images = $xml->xpath('//img');
				if(!empty($images)) {
					return $images[0]['src'];
				}
			} else {
				return False;	
			}
		} catch (Exception $e) {
			return False;
		}
    }
    return False;
}


function laechonw_version() {
	return LAECHONW_PLUGIN_VERSION;
}


?>